//+------------------------------------------------------------------+
//|                                         Chaikin's Volatility.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
//mod2008      ki
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
//----
#property indicator_separate_window
#property indicator_buffers 2
//----
#property indicator_color1 Red
#property indicator_color2 Blue
//---- input parameters
extern int       iPeriod      =9;

extern int       maPeriod     =13;
extern int       maSlowPeriod =26;
extern int       maMode       =1;

extern int       RocType      =1;
//---- buffers
double chaikin[];
double slowchaikin[];
double hl[];
double emahl[];
double slowemahl[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexStyle  (0,DRAW_LINE);
   SetIndexBuffer (0,chaikin);
   SetIndexStyle  (1,DRAW_LINE);
   SetIndexBuffer (1,slowchaikin);

   SetIndexBuffer (2,hl);
   SetIndexBuffer (3,emahl);
   SetIndexBuffer (4,slowemahl);

   SetIndexLabel  (0,"ChV fast");
   SetIndexLabel  (1,"ChV slow");

   IndicatorShortName  ("Chaikin\'sV  MA"+maPeriod+", MA"+maSlowPeriod+", i"+iPeriod+" ");


   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;

//----

   for (i=limit; i>=0; i--)

      hl[i]=High[i]-Low[i];
    
 
   for  (i=limit; i>=0; i--)       
      {
      emahl[i]    = iMAOnArray(hl,0,maPeriod,0,maMode,i);
      slowemahl[i]= iMAOnArray(hl,0,maSlowPeriod,0,maMode,i);
      }
      

    for (i=limit;i>=0;i--)
    if (emahl[i+iPeriod]!=0 && slowemahl[i+iPeriod]!=0 && slowemahl[i+maSlowPeriod]!=0)
     { 
                     chaikin[i]     =((emahl[i]        -emahl[i+iPeriod])     / emahl    [i+iPeriod])     *100;
     if (RocType==0) slowchaikin[i] =((slowemahl[i]-slowemahl[i+iPeriod])     / slowemahl[i+iPeriod])     *100;
     if (RocType==1) slowchaikin[i] =((slowemahl[i]-slowemahl[i+iPeriod])     / slowemahl[i+maSlowPeriod])*100;
     if (RocType==2) slowchaikin[i] =((slowemahl[i]-slowemahl[i+maSlowPeriod])/ slowemahl[i+maSlowPeriod])*100;
     if (RocType >2) RocType=2;
      }

//----
   return(0);
  }
//+------------------------------------------------------------------+